;void  delete_left(strg,border);
;  unsigned char  *strg,border;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _delete_left
_delete_left proc near
	mov  _error_code,0	;assume no error
	push bp			;
	mov  bp,sp		;set up stack frame
	push di			;
	push si			;
	push ds			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	les  di,dword ptr [bp+4] ;ES:DI pts to string
	lds  si,dword ptr [bp+4] ;so does DS:SI
	mov  bl,[bp+8]		;get border char
	jmp  short L1		;jump ahead
L0:	mov  di,[bp+4]		;NEAR case
	mov  si,di		;
	mov  ax,ds		;ES = DS
	mov  es,ax		;
	mov  bl,[bp+6]		;
L1:	cmp  byte ptr[si],0	;test for null string
	je   L5			;quit if null
L2:	mov  al,[si]		;seek border char
	cmp  al,0		;end of string?
	je   L5			;quit if not found
	cmp  al,bl		;matches border char?
	je   L3			;jump if so
	inc  si			;else forward ptr
	jmp  short L2		;loop
L3:	mov  al,[si]		;now transfer chars
	mov  es:[di],al		;write the char
	inc  si			;forward ptrs
	inc  di			;
	cmp  al,0		;end of string yet?
	je   L4			;jump if so
	jmp  short L3		;loop
L4:	pop  ds			;restore DS
	jmp  short L6		;
L5:	pop  ds			;---error case:
	inc  _error_code	;1 = null string or char not found
L6:	pop  si			;
	pop  di			;
	pop  bp			;restore BP
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_delete_left ENDP
_TEXT	ENDS
	END
