;unsigned short  available_pages();

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _available_pages
_available_pages proc near
	mov  ah,42h		;function number
	int  67H		;EMS interrupt
	mov  _error_code,0	;0 = successful
	or   ah,ah		;test if OK
	jz   L1			;jump if no error
	inc  _error_code	;1 = software malfunction
	cmp  ah,80h		;test error type
	je   L1			;jump if error 1
	inc  _error_code	;2 = hardware malfunction
L1:	mov  ax,bx		;set return value
	cmp  _memory_model,0	;quit
	jle  Quit		;
	db   0CBh		;RET far
Quit:	ret			;RET near
_available_pages endp
_TEXT	ENDS
	END
