;unsigned short  frame_address();

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _frame_address
_frame_address proc near
	mov  ah,41h		;function number
	int  67H		;EMS interrupt
	mov  _error_code,0	;0 = no error
	or   ah,ah		;0 if successful
	jz   L1			;jump if no error
	inc  _error_code	;1 = software malfunction
	cmp  ah,80h		;test 
	je   L1			;jump if error 1
	inc  _error_code	;2 = hardware malfunction
L1:	mov  ax,bx		;set return value
	cmp  _memory_model,0	;quit
	jle  Quit		;
	db   0CBh		;RET far
Quit:	ret			;RET near
_frame_address endp
_TEXT	ENDS
	END
