;char  printer_ready();

	EXTRN  _memory_model:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME  CS:_TEXT
	PUBLIC  _printer_ready
_printer_ready proc near
	mov  ax,40h		;BIOS data area
	mov  es,ax		;pt ES to 0040:0000
	mov  dx,es:[8]		;get LPT1 base addr
	inc  dx			;offset to status reg
	in   al,dx		;get status byte
	mov  bl,1		;TRUE
	test al,1000b		;test bit 3
	jnz  L1			;jump if set
	mov  bl,0		;FALSE
L1:	mov  al,bl
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_printer_ready endp
_TEXT	ENDS
	END
