;void  delete_char(strg,ch);
;  unsigned char  *strg,ch;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _delete_char
_delete_char proc near
	mov  _error_code,1	;1 = null string
	push bp			;
	mov  bp,sp		;set up stack frame
	push di			;
	push si			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	les  di,dword ptr [bp+4]  ;get string address
	inc  bp			;
	inc  bp			;
	jmp  short L00		;
L0:	mov  ax,ds		;ES = DS
	mov  es,ax		;
	mov  di,[bp+4]		;
L00:	mov  bl,[bp+6]		;get char to delete
	cmp  byte ptr es:[di],0	;null string?
	je   L4			;
	mov  si,di		;copy string ptr
	dec  _error_code	;no error
L1:	mov  al,es:[di]		;get a char
	inc  di			;forward ptr
	cmp  al,bl		;target char?
	je   L1			;keep moving
	mov  es:[si],al		;else write the character
	inc  si			;forward ptr
	cmp  al,0		;end of string?
	jne  L1			;loop if not
	mov  _error_code,0	;no error
L4:	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_delete_char ENDP
_TEXT	ENDS
	END
