;void  delete_range(strg,ch_1,ch_2);
;  unsigned char  *strg,ch_1,ch_2;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _delete_range
_delete_range proc near
	mov  _error_code,1	;1 = null string
	push bp			;
	mov  bp,sp		;set up stack frame
	push di			;
	push si			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	les  di,dword ptr [bp+4]  ;get string address
	inc  bp			;
	inc  bp			;
	jmp  short L00		;
L0:	mov  ax,ds		;ES = DS
	mov  es,ax		;
	mov  di,[bp+4]		;
L00:	mov  bl,[bp+6]		;get first char in range
	mov  bh,[bp+8]		;get second char in range
	cmp  bl,bh		;first char larger?
	jae  L1			;jump if so
	xchg bh,bl		;else exchange
L1:	cmp  byte ptr es:[di],0	;null string?
	je   L4			;
	mov  si,di		;copy string ptr
	dec  _error_code	;no error
L2:	mov  al,es:[di]		;get a char
	inc  di			;forward ptr
	cmp  al,bl		;compare to high end of range
	ja   L3			;go write it if out of range
	cmp  al,bh		;compare to low end of range
	jnb  L2			;loop if char is in range
L3:	mov  es:[si],al		;else write the character
	inc  si			;forward ptr
	cmp  al,0		;end of string?
	jne  L2			;loop if not
	mov  _error_code,0	;no error
L4:	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_delete_range ENDP
_TEXT	ENDS
	END
