;void  decompress_text(strg,return_strg,del_ch,flag_ch);
;  unsigned char  *strg,*return_strg,del_ch,flag_ch;

	EXTRN  _memory_model:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _decompress_text
_decompress_text proc near
	push bp			;
	mov  bp,sp		;set stack frame
	push di			;
	push si			;
	push ds			;save DS
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near	
	lds  si,dword ptr[bp+4] ;DS:SI points to source string
	les  di,dword ptr[bp+8] ;ES:DI points to return string
	add  bp,4		;adjust stack pointer
	jmp  short L00		;jump ahead
L0:	mov  ax,ds		;near case:
	mov  es,ax		;
	mov  si,[bp+4]		;
	mov  di,[bp+6]		;
L00:	mov  dh,[bp+10]		;flag character to DH
	mov  dl,[bp+8]		;fill character to DL
	mov  byte ptr es:[di],0	;0 ret strg len if error
	cmp  byte ptr [si],0	;test for null input string
	je   L6			;quit if null
L1:	mov  al,[si]		;get char from Strg
	or   al,al		;end of string?
	je   L5			;quit if so
	cmp  al,dh		;flag character?
	jne  L3			;jump ahead if not
	inc  si			;forward source ptr
	mov  al,[si]		;get the fill char count
	sub  al,128		;sub 128 from counter
L2:	mov  es:[di],dl		;write fill char
	inc  di			;forward ret strg ptr
	dec  al			;decrement fill counter
	jnz  L2			;loop till finished
	dec  di			;adjust ptr backwards
	jmp  short L4		;go do next char in Strg
L3:	mov  es:[di],al		;write char in ret strg
L4:	inc  di			;forward target ptr
	inc  si			;forward source ptr
	jmp  short L1		;go get next char
L5:	inc  di			;forward return strg ptr
	mov  byte ptr es:[di],0 ;set terminating null
L6:	pop  ds			;
	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_decompress_text ENDP
_TEXT	ENDS
	END
