;void  left_end(strg,return_strg,border);
;  unsigned char  *strg,*return_strg,border;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _left_end
_left_end proc near
	push bp			;
	mov  bp,sp		;set up stack frame
	push di			;
	push si			;
	push ds			;
	mov  _error_code,1	;1 = error
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	lds  si,dword ptr[bp+4] ;strg
	les  di,dword ptr[bp+8] ;return strg
	mov  bh,[bp+12]		;border char
	jmp  short L1		;
L0:	mov  si,[bp+4]		;NEAR case
	mov  di,[bp+6]		;
	mov  bh,[bp+8]		;
	mov  ax,ds		;ES = DS
	mov  es,ax		;
L1:	mov  al,[si]		;get a char
	cmp  al,bh		;border char?
	je   L2			;jump if so
	mov  es:[di],al		;transfer the char
	cmp  al,0		;end of string?
	je   L3			;quit if so (error)
	inc  si			;forward pointers
	inc  di			;
	jmp  short L1		;loop
L2:	mov  byte ptr es:[di],0 ;add terminator
	pop  ds			;no error
	dec  _error_code	;
	jmp  short L4		;
L3:	pop  ds			;restore DS
L4:	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_left_end ENDP
_TEXT	ENDS
	END
