;void  right_end(strg,return_strg,border_char);
;  unsigned char  *strg,*return_strg,border_char;

	EXTRN  _memory_model:byte
	EXTRN  _error_code:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _right_end
_right_end proc near
	push bp			;
	mov  bp,sp		;set up stack frame
	push di			;
	push si			;
	push ds			;
	mov  dl,1		;errorcode 1 = error
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	cmp  _memory_model,2	;data near or far?
	jb   L0			;jump if near
	lds  si,dword ptr[bp+8] ;return strg
	les  di,dword ptr[bp+4] ;strg
	mov  dh,[bp+12]		;border char
	jmp  short L00		;
L0:	mov  si,[bp+6]		;NEAR case
	mov  di,[bp+4]		;
	mov  dh,[bp+8]		;
	mov  ax,ds		;ES = DS
	mov  es,ax		;
L00:	cmp  byte ptr es:[di],0	;null string
	je   L3			;quit if null
	dec  dl			;errorcode 0 = no error
	mov  cx,255		;find end of string
	mov  bx,cx		;
	mov  al,0		;
	cld			;
	repne scasb		;
	dec  di			;di now points to terminator
	sub  bx,cx		;
	mov  cx,bx		;BX = string length
	mov  al,dh		;fetch border char
	std			;will seek border char
	repne scasb		;
	jz   L1			;jump if border char not found
	dec  di			;case for border char not found
	mov  dl,1		;errorcode 1 = error
L1:	inc  di			;point di to char following border
	inc  di			;
L2:	mov  al,es:[di]		;transfer the characters
	mov  [si],al		;
	cmp  al,0		;end of string?
	je   L3			;jump if so
	inc  di			;
	inc  si			;
	jmp  short L2		;loop
L3:	pop  ds			;
	mov  _error_code,dl	;
	pop  si			;
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_right_end ENDP
_TEXT	ENDS
	END
